=== debian/changelog ===
uftrace (0.9.3-1ubuntu1) focal; urgency=medium

  * Build using python2.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 01 Apr 2020 13:39:56 +0200

uftrace (0.9.3-1) unstable; urgency=low

  * New upstream release
  * Adds support for nodoc build option
  * Adds i386 as a build target
  * Make build reproducible (this mostly involved adding the
    -ffile-prefix-map compiler option)
  * Adds support for autopkgtest
  * Add Rules-Requires-Root: no
  * Bump Standards-Version to 4.4.0
  * Install private shared objects to /usr/lib/$(DEB_HOST_MULTIARCH)/uftrace

 -- paul cannon <pik@debian.org>  Wed, 18 Sep 2019 21:14:16 -0500

uftrace (0.9.0-1) unstable; urgency=medium

  * New upstream release:
    + Fixes FTBFS on buster/sid (closes: #906512).
    + Now reports correct version (closes: #886863).
  * Adds arm64 as a build target (closes: #898000, and thank you, Matthias
    Klose).
  * Add new (optional) build dependencies for the sake of features:
    pkg-config, libpython2.7-dev, libdw-dev, libncursesw5-dev
  * Bump Standards-Version to 4.2.1.

 -- paul cannon <pik@debian.org>  Tue, 11 Sep 2018 16:19:19 -0500
