=== debian/tests/control ===
Test-Command: cd tests && objdir=/usr/bin python2 runtest.py
Depends: @, build-essential, python2
Restrictions: allow-stderr
