## uftrace 0.9.4

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION := 0.9.3
+VERSION := 0.9.4
 
 # Makefiles suck: This macro sets a default value of $(2) for the
 # variable named by $(1), unless the variable has been set by
@@ -19,8 +19,8 @@
 uname_M := $(shell uname -m 2>/dev/null || echo not)
 
 ARCH ?= $(shell echo $(uname_M) | sed -e s/i.86/i386/ -e s/arm.*/arm/ )
-ifeq ($(ARCH),x86_64)
-  ifneq ($(findstring m32,$(CFLAGS)),)
+ifneq ($(findstring x86,$(ARCH)),)
+  ifneq ($(findstring m32,$(CC) $(CFLAGS)),)
     override ARCH := i386
   endif
 endif
@@ -30,6 +30,11 @@
 libdir = $(prefix)/lib
 etcdir = $(prefix)/etc
 mandir = $(prefix)/share/man
+docdir = $(srcdir)/doc
+
+ifeq ($(DOCLANG), ko)
+  docdir = $(srcdir)/doc/ko
+endif
 
 srcdir = $(CURDIR)
 # set objdir to $(O) by default (if any)
@@ -86,28 +91,44 @@
 endif
 
 ifeq ($(TRACE), 1)
-  UFTRACE_CFLAGS    += -pg -fno-omit-frame-pointer
-  DEMANGLER_CFLAGS  += -pg -fno-omit-frame-pointer
-  SYMBOLS_CFLAGS    += -pg -fno-omit-frame-pointer
-  TRACEEVENT_CFLAGS += -pg -fno-omit-frame-pointer
-  TEST_CFLAGS       += -pg -fno-omit-frame-pointer
+  TRACE_CFLAGS      := -pg -fno-omit-frame-pointer
+  UFTRACE_CFLAGS    += $(TRACE_CFLAGS)
+  DEMANGLER_CFLAGS  += $(TRACE_CFLAGS)
+  SYMBOLS_CFLAGS    += $(TRACE_CFLAGS)
+  TRACEEVENT_CFLAGS += $(TRACE_CFLAGS)
+  TEST_CFLAGS       += $(TRACE_CFLAGS)
   # cannot add -pg to LIB_CFLAGS because mcount() is not reentrant
 endif
 
 ifeq ($(COVERAGE), 1)
-  COMMON_CFLAGS += -O0 -g --coverage -U_FORTIFY_SOURCE
-  LIB_CFLAGS    += -O0 -g --coverage -U_FORTIFY_SOURCE
-  TEST_CFLAGS   += -O0 -g --coverage -U_FORTIFY_SOURCE
+  COVERAGE_CFLAGS := -O0 -g --coverage -U_FORTIFY_SOURCE
+  COMMON_CFLAGS   += $(COVERAGE_CFLAGS)
+  LIB_CFLAGS      += $(COVERAGE_CFLAGS)
+  TEST_CFLAGS     += $(COVERAGE_CFLAGS)
 
   LIB_LDFLAGS   += --coverage
 endif
 
 ifeq ($(ASAN), 1)
-  UFTRACE_CFLAGS    += -O0 -g -fsanitize=address -fsanitize=leak
-  DEMANGLER_CFLAGS  += -O0 -g -fsanitize=address -fsanitize=leak
-  SYMBOLS_CFLAGS    += -O0 -g -fsanitize=address -fsanitize=leak
-  TRACEEVENT_CFLAGS += -O0 -g -fsanitize=address -fsanitize=leak
-  TEST_CFLAGS       += -O0 -g -fsanitize=address -fsanitize=leak
+  ASAN_CFLAGS       := -O0 -g -fsanitize=address,leak
+  UFTRACE_CFLAGS    += $(ASAN_CFLAGS)
+  DEMANGLER_CFLAGS  += $(ASAN_CFLAGS)
+  SYMBOLS_CFLAGS    += $(ASAN_CFLAGS)
+  TRACEEVENT_CFLAGS += $(ASAN_CFLAGS)
+  TEST_CFLAGS       += $(ASAN_CFLAGS)
+endif
+
+ifneq ($(SAN),)
+  ifeq ($(SAN), all)
+    SAN_CFLAGS := -O0 -g -fsanitize=address,leak,undefined
+  else
+    SAN_CFLAGS := -O0 -g -fsanitize=$(SAN)
+  endif
+  UFTRACE_CFLAGS    += $(SAN_CFLAGS)
+  DEMANGLER_CFLAGS  += $(SAN_CFLAGS)
+  SYMBOLS_CFLAGS    += $(SAN_CFLAGS)
+  TRACEEVENT_CFLAGS += $(SAN_CFLAGS)
+  TEST_CFLAGS       += $(SAN_CFLAGS)
 endif
 
 export UFTRACE_CFLAGS LIB_CFLAGS TEST_CFLAGS TEST_LDFLAGS
@@ -163,7 +184,7 @@
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/debug.c $(srcdir)/utils/regs.c
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/rbtree.c $(srcdir)/utils/filter.c
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/demangle.c $(srcdir)/utils/utils.c
-LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/script.c $(srcdir)/utils/script-python.c
+LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/script.c $(srcdir)/utils/script-python.c $(srcdir)/utils/script-luajit.c
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/auto-args.c $(srcdir)/utils/dwarf.c
 LIBMCOUNT_UTILS_SRCS += $(wildcard $(srcdir)/utils/symbol*.c)
 LIBMCOUNT_UTILS_OBJS := $(patsubst $(srcdir)/utils/%.c,$(objdir)/libmcount/%.op,$(LIBMCOUNT_UTILS_SRCS))
@@ -282,12 +303,3 @@
 	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(etcdir)/bash_completion.d
 ifneq ($(wildcard $(elfdir)/lib/libelf.so),)
 ifeq ($(wildcard $(prefix)/lib/libelf.so),)
-	# install libelf only when it's not in the install directory.
-	$(call QUIET_INSTALL, libelf)
-	$(Q)$(INSTALL) $(elfdir)/lib/libelf.so   $(DESTDIR)$(libdir)/libelf.so
-endif
-endif
-	$(call QUIET_INSTALL, uftrace)
-	$(Q)$(INSTALL) $(objdir)/uftrace         $(DESTDIR)$(bindir)/uftrace
-	$(call QUIET_INSTALL, libmcount)
-	$(Q)$(INSTALL) $(objdir)/libmcount/libmcount.so   $(DESTDIR)$(libdir)/libmcount.so
