=== check-deps/Makefile ===
--- 
+++ 
@@ -4,6 +4,8 @@
 CHECK_LIST += have_libelf
 CHECK_LIST += cc_has_mno_sse2
 CHECK_LIST += have_libpython2.7
+CHECK_LIST += have_libpython3
+CHECK_LIST += have_libluajit
 CHECK_LIST += perf_clockid
 CHECK_LIST += perf_context_switch
 CHECK_LIST += arm_has_hardfp
@@ -23,6 +25,10 @@
 LDFLAGS_have_libelf = -lelf
 CFLAGS_cc_has_mno_sse2 = -mno-sse2
 LDFLAGS_have_libpython2.7 = -lpython2.7
+CFLAGS_have_libpython3 = $(shell python3-config --cflags 2> /dev/null)
+LDFLAGS_have_libpython3 = $(shell python3-config --libs 2> /dev/null)
+CFLAGS_have_libluajit = $(shell pkg-config --cflags luajit 2> /dev/null)
+LDFLAGS_have_libluajit = $(shell pkg-config --libs  luajit 2> /dev/null)
 CFLAGS_have_libncurses  = $(shell pkg-config --cflags ncursesw 2> /dev/null)
 LDFLAGS_have_libncurses = $(shell pkg-config --libs   ncursesw 2> /dev/null)
 CFLAGS_have_libdw  = $(shell pkg-config --cflags libdw 2> /dev/null)
