=== debian/changelog ===
uftrace (0.9.4-0.2ubuntu1) hirsute; urgency=medium

  * d/p/0001-test-Robustify-mcount_wrap_dlopen-test.patch: Import patch from
    upstream Git to fix a failing test.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 02 Jan 2021 18:47:36 -0500

uftrace (0.9.4-0.2) unstable; urgency=high

  * Non-maintainer upload.
  * Remove the autopkgtest for now, it doesn't fail when tests fail
    but fails for other reasons on arm64. (Closes: #947089)

 -- Adrian Bunk <bunk@debian.org>  Wed, 22 Apr 2020 17:06:49 +0300

uftrace (0.9.4-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
    - Fixes FTBFS on armhf. (Closes: #947089)

 -- Adrian Bunk <bunk@debian.org>  Mon, 13 Apr 2020 16:18:27 +0300
