=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: uftrace
 Section: utils
 Priority: optional
-Maintainer: paul cannon <pik@debian.org>
-Build-Depends: debhelper (>= 9), libelf-dev, pandoc, python2, pkg-config,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: paul cannon <pik@debian.org>
+Build-Depends: debhelper (>= 9), libelf-dev, pandoc, python, pkg-config,
  libpython2.7-dev, libdw-dev, libncursesw5-dev, libcapstone-dev,
  bash-completion
 Standards-Version: 4.4.0
